--[[ MC.events ]]

function MC.events.OnShow( this )
	UIPanelBackdropFrame_SetTexture( this, "Interface/Common/PanelCommonFrame", 256, 256 );
	MC.ui.MainFormOnShow();
end;

function MC.events.VariablesLoaded()
	local hRet;
	hRet, mCardBookVariables = MLib.CheckVariables( mCardBookVariables, MC.DefaultConfig );
	if( hRet == MLIB_CHECKVARIABLES_FAILED )then
		MR.Message( "|cffFF0000Ошибка запуска! Исполнение прекращено!|r" );
		MR.PANIC = true;
		return nil;
	end;
	
	if( hRet == MLIB_CHECKVARIABLES_FIRSTSTART )then
		MR.Message( "Первый запуск! Установка параметров по умолчанию." );
	end;
	
	SaveVariables( "mCardBookVariables" );
	LuaFunc_InitCardInfo();

	if( mCardBookVariables.CardList == nil )then
		MC.tools.CreateCardList();
		mCardBookVariables.CardList = MC.CardList;
	else
		MC.CardList = mCardBookVariables.CardList;
		MC.Vars.NumCards = table.getn( MC.CardList );
		MC.tools.UpdateCardList();
	end;
	MC.Message( MC.Name .. " " .. MC.Version .. " успешно загружен." );

	CardBookFrameCardImage.angleX = 0;
	CardBookFrameCardImage.angleY = 0;

	CardBookFrameCardImage.cameraPosX = 0;
	CardBookFrameCardImage.cameraPosY = 0;
	CardBookFrameCardImage.cameraPosZ = -1;	
	
	CardBookFrameCard:SetParent( mCardBookFrameCardBackDrop );
	CardBookFrameCard:ClearAllAnchors();
	CardBookFrameCard:SetAnchor( "TOPLEFT", "TOPLEFT", mCardBookFrameCardBackDrop, 3, 3 );
	
	CardBookFrameCardSP:ClearAllAnchors();
	CardBookFrameCardSP:SetAnchor( "TOPLEFT", "TOPLEFT", CardBookFrameCardExplain, 22, 55 );
	
	MC.ui.CountMessage();

	UIDropDownMenu_Initialize( mCardBookFrame_Race, MC.ui.IDRace );
	UIDropDownMenu_SetSelectedID( mCardBookFrame_Race, 1 );
	UIDropDownMenu_SetWidth( mCardBookFrame_Race, 130 );

	UIDropDownMenu_Initialize( mCardBookFrame_Stat, MC.ui.IDStat );
	UIDropDownMenu_SetSelectedID( mCardBookFrame_Stat, 1 );
	UIDropDownMenu_SetWidth( mCardBookFrame_Stat, 130 );
end;

function MC.events.CardBookUpdate()
	MC.tools.UpdateCardList();
	MC.ui.CountMessage();
	if( mCardBookFrame:IsVisible() )then
		MC.ui.MainFormOnShow();
	end
end;

function MC.events.MouseOverUnit()
	local WMapID = GetCurrentWorldMapID();
	if( WMapID == 402 )or( ( WMapID >= 440 )and( WMapID < 450 ) )then -- Skip PvP zones
		return false;
	end;
	if( not GameTooltip:IsVisible() )or( not UnitCanAttack("player", "mouseover") )or( UnitIsPlayer("mouseover") )then
		return false;
	end;

	MC.ui.ShowUnitTooltip();
end;

function MC.events.OnEvent(event)
	--[[ Выключаем подсказку pbInfo ]]
	if( pbInfoSettings ~= nil )then
		pbInfoSettings["MODIFYTOOLTIP"] = false;
	end;

	if( event == "VARIABLES_LOADED" )then
		MC.events.VariablesLoaded();
	end;
	
	if( event == "CARDBOOKFRAME_UPDATE" )then
		MC.events.CardBookUpdate();
	end;
	
	if( event == "UPDATE_MOUSEOVER_UNIT" )then
		MC.events.MouseOverUnit();
	end;
end;

--[[ /run dofile("Interface/AddOns/mCardBook/code/events.lua"); ]]