GameTooltip_obj = _G.GameTooltip;
GameTooltipHyperLink_obj = _G.GameTooltipHyperLink;

local OnShow_CardFrame_orig = OnShow_CardFrame;
function OnShow_CardFrame( this )
	OnShow_CardFrame_orig( this );
	HideUIPanel( this );
	if( mCardBookFrame:IsVisible() )then
		HideUIPanel( mCardBookFrame );
	else
		ShowUIPanel( mCardBookFrame );
	end;
end;

function AddTooltipLines( TT, stCard )
	if( stCard == nil )then
		local origtooltipname = GameTooltip_obj:GetName();
		local itemName = getglobal(origtooltipname .. "TextLeft1"):GetText();
		stCard = MC.tools.GetCardByName( itemName:sub(TEXT("SYS_CARD_TITLE"):len() + 1) );
	end;
	TT:AddSeparator();
	TT:AddLine( "|cff00B1E1" .. stCard["descr"] .. "|r" );
	if( stCard["owned"] )then
		TT:AddLine( MC.ui.PercentFormat( 100, "Карта получена" ) );
	else
		TT:AddLine( MC.ui.PercentFormat( 0, "Карта отсутствует" ) );
	end;
	--TT:AddLine( "ID Карты: " .. tostring( itemID ) );
end;

function MCAddCardLines( link )
	local itemID = MC.tools.itemID( link );
	local itemName = MC.tools.itemName( link );

	if( itemName == nil )then return nil; end;
	
	if( itemName:sub( 1, TEXT("SYS_CARD_TITLE"):len() ) == TEXT("SYS_CARD_TITLE") )then
		local stCard = MC.tools.GetCardByName( itemName:sub(TEXT("SYS_CARD_TITLE"):len() + 1) );
		AddTooltipLines( GameTooltip_obj, stCard );
	end;
end;
function MCAddCardLinesHL( link )
	local itemID = MC.tools.itemID( link );
	local itemName = MC.tools.itemName( link );

	if( itemName == nil )then return nil; end;
	
	if( itemName:sub( 1, TEXT("SYS_CARD_TITLE"):len() ) == TEXT("SYS_CARD_TITLE") )then
		local stCard = MC.tools.GetCardByName( itemName:sub(TEXT("SYS_CARD_TITLE"):len() + 1) );
		AddTooltipLines( GameTooltipHyperLink_obj, stCard );
	end;
end;
function MCAddCardLinesTT()
	local origtooltipname = GameTooltip_obj:GetName();
	local itemName = getglobal(origtooltipname .. "TextLeft1"):GetText();
	itemName = itemName:sub(TEXT("SYS_CARD_TITLE"):len() + 1);

	if( itemName == nil )then return nil; end;
	
	if( itemName:sub( 1, TEXT("SYS_CARD_TITLE"):len() ) == TEXT("SYS_CARD_TITLE") )then
		local stCard = MC.tools.GetCardByName( itemName:sub(TEXT("SYS_CARD_TITLE"):len() + 1) );
		AddTooltipLines( GameTooltip_obj, stCard );
	end;
end;

local SetAuctionBrowseItem_orig = GameTooltip_obj.SetAuctionBrowseItem;
function GameTooltip:SetAuctionBrowseItem(id)
	SetAuctionBrowseItem_orig(GameTooltip_obj, id);
	MCAddCardLines( GetAuctionBrowseItemLink( id ) )
end

local SetAuctionBidItem_orig = GameTooltip_obj.SetAuctionBidItem;
function GameTooltip:SetAuctionBidItem(id)
	SetAuctionBidItem_orig(GameTooltip_obj, id);
	MCAddCardLinesTT();
end

local SetAuctionSellItem_orig = GameTooltip_obj.SetAuctionSellItem;
function GameTooltip:SetAuctionSellItem(id)
	SetAuctionSellItem_orig(GameTooltip_obj, id);
	MCAddCardLinesTT();
end

local SetAuctionItem_orig = GameTooltip_obj.SetAuctionItem;
function GameTooltip:SetAuctionItem()
	SetAuctionItem_orig(GameTooltip_obj);
	MCAddCardLinesTT();
end

local SetHistoryItem_orig = GameTooltip_obj.SetHistoryItem;
function GameTooltip:SetHistoryItem(id)
	SetHistoryItem_orig(GameTooltip_obj, id);
	MCAddCardLinesTT();
end

local SetInboxItem_orig = GameTooltip_obj.SetInboxItem;
function GameTooltip:SetInboxItem(id)
	SetInboxItem_orig(GameTooltip_obj, id);
	MCAddCardLinesTT();
end

local SetSendMailItem_orig = GameTooltip_obj.SetSendMailItem;
function GameTooltip:SetSendMailItem()
	SetSendMailItem_orig(GameTooltip_obj);
	MCAddCardLinesTT();
end


local SetBagItem_orig = GameTooltip_obj.SetBagItem;
function GameTooltip:SetBagItem(id)
	SetBagItem_orig (GameTooltip_obj, id);
	MCAddCardLines( GetBagItemLink(id) )
end

local SetBankItem_orig = GameTooltip_obj.SetBankItem;
function GameTooltip:SetBankItem(id)
	SetBankItem_orig(GameTooltip_obj, id);
	MCAddCardLines( GetBankItemLink(id) )
end

local SetHouseItem_orig = GameTooltip_obj.SetHouseItem;
function GameTooltip:SetHouseItem(emplacementID, id)
	SetHouseItem_orig(GameTooltip_obj, emplacementID, id);
	MCAddCardLines( Houses_GetItemLink(emplacementID, id) );
end

local SetHyperLink_orig = GameTooltip_obj.SetHyperLink;
function GameTooltip:SetHyperLink(link)
	SetHyperLink_orig(GameTooltip_obj, link);
	MCAddCardLines( link )
end

local SetBootyItem_orig = GameTooltip_obj.SetBootyItem;
function GameTooltip:SetBootyItem(id)
	SetBootyItem_orig(GameTooltip_obj, id);
	MCAddCardLines( GetBootyItemLink(id) )
end

local SetLootItem_orig = GameTooltip_obj.SetLootItem;
function GameTooltip:SetLootItem(info1, info2, info3, info4)
	SetLootItem_orig(GameTooltip_obj, info1, info2, info3, info4);
	me.ShowTooltipBySelf(self);
	MCAddCardLinesTT();
end

local SetQuestItem_orig = GameTooltip_obj.SetQuestItem;
function GameTooltip:SetQuestItem(rewardType, id)
	SetQuestItem_orig(GameTooltip_obj, rewardType, id);
	MCAddCardLinesTT();
end

local SetTradePlayerItem_orig = GameTooltip_obj.SetTradePlayerItem;
function GameTooltip:SetTradePlayerItem(id)
	SetTradePlayerItem_orig(GameTooltip_obj, id);
	MCAddCardLinesTT();
end

local SetTradeTargetItem_orig = GameTooltip_obj.SetTradeTargetItem;
function GameTooltip:SetTradeTargetItem(id)
	SetTradeTargetItem_orig(GameTooltip_obj, id);
	MCAddCardLinesTT();
end

local SetHyperLink_orig = GameTooltipHyperLink_obj.SetHyperLink;
function GameTooltipHyperLink:SetHyperLink(link)
	SetHyperLink_orig(GameTooltipHyperLink_obj, link);
	MCAddCardLinesHL( link )
end
