--[[ MC.tools ]]

function MC.tools.ExtractCard( id )
	local _CardList = MC.tools.GetFilteredCardList();
	i = id + mCardBookFrame_ScrollBar:GetValue()
	MC.ui.Dialog( "Подтверждение", "Вы уверены, что хотите изъять карту " .. string.format( MC.Qualities[ _CardList[i]["rare"] ], _CardList[i]["name"] ), id, "MCExtractCard" );
end;

function MCExtractCard( id )
	local _CardList = MC.tools.GetFilteredCardList();
	id = id + mCardBookFrame_ScrollBar:GetValue()
	LuaFunc_TakeOutCard( tonumber( _CardList[ id ]["hex"], 16 ) );
	for n = 1, #MC.CardList do
		if( _CardList[ id ]["hex"] == MC.CardList[ id ]["hex"] )then MC.CardList[ id ]["owned"] = false; end;
	end;
end;

function MC.tools.CreateCardList()
	MC.Vars.NumCards = 0;
	MC.CardList = {};
	MC.Vars.Owned = 0;
	local CardList = {};
	local _Races = {};
	
	for i = 0, MC.Vars.NumCategories do
		local nCardsInCat = LuaFunc_GetCardMaxCount(i);
		if nCardsInCat and nCardsInCat > 0 then
			for j = 1, nCardsInCat do
				local cID, cOwned, cName, cDescr, cRace, cRare, cResist, cStat = LuaFunc_GetCardInfo( i, j - 1 );
				local strIDhex = MC.tools.dec2hex(cID);
				local strCardName = MC.tools.GetCardName(strIDhex);
				if( not cName )or( cName == "" )or( cName:sub(1, 1) == "?" )then
					cName = strCardName;
				end;
				if( cName ~= "" )and( ( cName:sub(1,3) ~= "Sys" )or( cName:sub(-4) ~= "name" ) )then
					MC.Vars.NumCards = MC.Vars.NumCards + 1;
					local statval, statname = cStat:match( "%+?(%d+) +(.-) *$" );
					CardList[ strIDhex ] = {
						["hex"] = strIDhex,
						["name"] = cName,
						["owned"] = cOwned == 1,
						["descr"] = cDescr,
						["race"] = cRace,
						["rare"] = cRare + 2,
						["resist"] = cResist,
						["statname"] = statname,
						["statval"] = statval,
						["category"] = i,
						["num"] = j - 1,
					};
					MC.Vars.Owned = MC.Vars.Owned + cOwned;
					if( _Races[cRace] == nil )then _Races[cRace] = true; end;
				end;
			end;
		end;
	end;
	MC.Stats = {};
	for k, v in pairs( CardList ) do
		MC.CardList[ #MC.CardList + 1 ] = v;
		
		if( MC.Stats[ v["statname"] ] == nil )then
			if( v["statname"] ~= nil )then MC.Stats[ v["statname"] ] = { 0, 0 }; end;
		end;
		
		if( v["statname"] ~= nil )then
			if( v["owned"] )then
				MC.Stats[ v["statname"] ][ 1 ] = MC.Stats[ v["statname"] ][ 1 ] + v["statval"];
			end;
			MC.Stats[ v["statname"] ][ 2 ] = MC.Stats[ v["statname"] ][ 2 ] + v["statval"];
		end;
	end;
	MC.Vars["Races"] = {};
	for k, v in pairs( _Races ) do
		MC.Vars["Races"][ #MC.Vars["Races"] + 1 ] = k;
	end;
end;

function MC.tools.UpdateCardList()
	local oldOwned = MC.Vars.Owned;
	MC.Vars.Owned = 0;
	for i = 1, #MC.CardList do
		local cID, cOwned = LuaFunc_GetCardInfo( MC.CardList[i]["category"], MC.CardList[i]["num"] );
		MC.CardList[i]["owned"] = cOwned == 1;
		MC.Vars.Owned = MC.Vars.Owned + cOwned;
	end;
	MC.Stats = {};
	for k, v in pairs( MC.CardList ) do
		if( MC.Stats[ v["statname"] ] == nil )then
			if( v["statname"] ~= nil )then MC.Stats[ v["statname"] ] = { 0, 0 }; end;
		end;
		
		if( v["statname"] ~= nil )then
			if( v["owned"] )then
				MC.Stats[ v["statname"] ][ 1 ] = MC.Stats[ v["statname"] ][ 1 ] + v["statval"];
			end;
			MC.Stats[ v["statname"] ][ 2 ] = MC.Stats[ v["statname"] ][ 2 ] + v["statval"];
		end;
	end;
end;

function MC.tools.GetCardName( strIDhex )
	local ttip = getglobal( MC.ShortName .. "Tooltip" );
	local ttiptext = getglobal( MC.ShortName .. "TooltipTextLeft1" );
	ttip:SetText("")
	ttip:SetHyperLink( MC.tools.CreateLink( "item", strIDhex, "" ) );
	ttip:Hide();
	local name = ttiptext:GetText()
	name = name:sub( TEXT( "SYS_CARD_TITLE" ):len() + 1 );
	return name;
end

function MC.tools.CreateLink( linktype, data, text )
	return string.format( "|H%s:%s|h%s|h", linktype, data, text );
end;

function MC.tools.dec2hex( dec )
	return string.format( "%x", dec );
end;

function MC.tools.IsAmbientMob()
	local StartArea = { 
		[1] = { X1=0.18, Y1=0.56, X2=0.54, Y2=1 }, -- Howling Mountains
		[12] = { X1=0.43, Y1=0.32, X2=0.72, Y2=0.65 }, -- Elven Isle
		[10] = { X1=0.52, Y1=0.24, X2=1, Y2=0.48 }, -- Sascilia Steppes
		[31] = { X1=0.10, Y1=0.45, X2=0.25, Y2=0.70 } }; -- Yrvandis Hollows

	local mobLevel, _ = UnitLevel("mouseover");
	if mobLevel > 1 then return false; end

	local WMapID = GetCurrentWorldMapID();
	if not StartArea[WMapID] then return true; end
	
	local PosX, PosY = GetPlayerWorldMapPos();
	if StartArea[WMapID].X1 < PosX and PosX < StartArea[WMapID].X2 and
	   StartArea[WMapID].Y1 < PosY and PosY < StartArea[WMapID].Y2 then return false; end
	
	return true;
end

function MC.tools.GetCardByName( strName )
	for n = 1, #MC.CardList do
		if( MC.CardList[n]["name"] == strName )then return MC.CardList[n]; end;
	end;
	return nil;
end;

function MC.tools.GetFilteredCardList()
	local _CardList = {};
	
	for n = 1, #MC.CardList do
		local flag = true;

		if( MC.Vars["SelectedRace"] ~= -1 )and( MC.CardList[ n ]["race"] ~= MC.Vars["SelectedRace"] )then flag = false; end;
		if( MC.Vars["SelectedStat"] ~= "" )and( MC.CardList[ n ]["statname"] ~= MC.Vars["SelectedStat"] )then flag = false; end;
		
		if( flag )then _CardList[ #_CardList + 1 ] = MC.CardList[ n ]; end;
	end;
	
	return _CardList;
end;

function MC.tools.GetCardByName( sName )
	for n = 1, #MC.CardList do
		if( MC.CardList[ n ]["name"] == sName )then return MC.CardList[ n ]; end;
	end;
	return nil;
end;

--[[ |Hitem:<id> <bind type> <runes><plus><tiering><max dura> <stats>x7 <current dura> <hash>|h|cff<color>[<name>]|r|h ]]
function MC.tools.itemID( link )
    if( not link )then return nil; end;
    local id = link:match("^|H.-:([0-9a-f]+)");
	return Sol.math.HexToDec( id );
end

--[[ |Hitem:<id> <bind type> <runes><plus><tiering><max dura> <stats>x7 <current dura> <hash>|h|cff<color>[<name>]|r|h ]]
function MC.tools.itemName( link )
    if( not link )then return nil; end;
    local name = link:match("|h(.+)|h");
	if( MUIChatFrame ~= nil )then
		return name:sub( 12, -14 );
	else
		return name:sub( 12, -2 );
	end;
end

--[[ /run dofile("Interface/AddOns/mCardBook/code/tools.lua"); ]]
