--[[ MC.ui ]]

function MC.ui.MinimapButtonOnMouseOver( this )
	GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
	GameTooltip:SetText( MC.Name .. " " .. MC.Version, 1, 1, 1 );
	GameTooltip:AddSeparator();

	GameTooltip:AddLine( UI_MINIMAPBUTTON_MOVE, 0, 0.75, 0.95 );
	GameTooltip:Show();
end;

function MC.ui.Dialog(title, message, itemID, OnOkCloseFunction)
	MCDialogFrame_OkOnClose:SetText( "" );
	MCDialogFrame_itemID:SetText( "" );
	if( OnOkCloseFunction ~= nil )then MCDialogFrame_OkOnClose:SetText( OnOkCloseFunction ); end;
	if( itemID ~= nil )then MCDialogFrame_itemID:SetText( itemID ); end;
	MCDialogFrame_Title:SetText( MC.Name .. " " .. MC.Version .. ": " .. title );
	MCDialogFrame_Message:SetText( message );
	MCDialogFrame:Show();
end;

function MC.ui.OkCloseDialog()
	local OnClose = MCDialogFrame_OkOnClose:GetText();
	local itemID = MCDialogFrame_itemID:GetText();
	if( OnClose ~= "" )then
		local exec = _G[OnClose];
		if( exec ~= nil )then exec( itemID ); end;
	end;
	MCDialogFrame:Hide();
end;

function MC.ui.CancelCloseDialog()
	MCDialogFrame:Hide();
end;

function MC.ui.MainFormOnShow()
	mCardBookFrame_Title:SetText( "Атлас монстров (" .. MC.Name .. " " .. MC.Version .. ")" );
	
	mCardBookFrameStats_Header_Title:SetText( "Суммарно параметры" );
	for n = 1, #MC.StatLabels do
		_G[ "mCardBookFrameStats_label" .. n ]:SetText( MC.StatLabels[ n ] );
		local nStatHave = MC.Stats[ MC.StatLabels[ n ] ][ 1 ];
		local nStatMax = MC.Stats[ MC.StatLabels[ n ] ][ 2 ];
		local percent = math.floor( nStatHave * 100 / nStatMax );
		_G[ "mCardBookFrameStats_labelex" .. n ]:SetText( MC.ui.PercentFormat( percent, nStatHave ) );
		_G[ "mCardBookFrameStats_labelmax" .. n ]:SetText( nStatMax );
		_G[ "mCardBookFrameStats_labelper" .. n ]:SetText( "(" .. MC.ui.PercentFormat( percent, tostring( percent ) .. "%" ) .. ")" );
	end;
	
	percent = 100;
	local HP = 0;
	local MP = 0;
	local PA = 0;
	local MA = 0;
	local PD = 0;
	local MD = 0;
	local PACC = 0;
	local MACC = 0;
	local PDR = 0;
	local RES = 0;
	local HB = 0;
	local HPR = 0;
	local MPR = 0;
	local class = UnitClassToken("player");
	if( class == "WARRIOR" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 2 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );

		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 2.3 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 2.2 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "RANGER" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PA = PA + math.floor( MC.Stats["Ловкость"][1] );
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );
		
		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 1.8 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 2.6 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "THIEF" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 1.2 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PA = PA + math.floor( MC.Stats["Ловкость"][1] * 1.3 );
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 1.8 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.25 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 2.3 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "MAGE" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 0.8 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 1.5 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );
		PA = PA + math.floor( MC.Stats["Интеллект"][1] * 0.5 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 3 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "AUGUR" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 0.8 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 1.5 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );
		PA = PA + math.floor( MC.Stats["Интеллект"][1] * 0.5 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 3.2 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "KNIGHT" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 1.5 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 3 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );
		PA = PA + math.floor( MC.Stats["Интеллект"][1] * 0.5 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 2.4 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "DRUID" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 0.8 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 1.5 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 3 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "PSYRON" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 2 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 2.3 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 2.2 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;
	if( class == "HARPSYN" )then
		PA = PA + math.floor( MC.Stats["Сила"][1] * 0.8 );
		HP = HP + math.floor( MC.Stats["Сила"][1] * 0.2 );
		
		PDR = PDR + math.floor( MC.Stats["Ловкость"][1] * 0.7778 );
		PACC = PACC + math.floor( MC.Stats["Ловкость"][1] * 0.9 );

		PD = PD + math.floor( MC.Stats["Выносливость"][1] * 1.5 );
		HP = HP + math.floor( MC.Stats["Выносливость"][1] * 5 );
		HPR = HPR + math.floor( MC.Stats["Выносливость"][1] * 0.05 );
		
		MP = MP + math.floor( MC.Stats["Интеллект"][1] );
		MA = MA + math.floor( MC.Stats["Интеллект"][1] * 2 );
		PA = PA + math.floor( MC.Stats["Интеллект"][1] * 0.5 );

		MP = MP + math.floor( MC.Stats["Мудрость"][1] * 5 );
		MPR = MPR + math.floor( MC.Stats["Мудрость"][1] * 0.5 );
		MD = MD + math.floor( MC.Stats["Мудрость"][1] * 3.0 );
		MACC = MACC + math.floor( MC.Stats["Мудрость"][1] * 0.9 );
		RES = RES + math.floor( MC.Stats["Мудрость"][1] * 0.7778 );
		HB = HB + math.floor( MC.Stats["Мудрость"][1] * 0.3 );
	end;

	PA = PA + math.floor( MC.Stats["Физическая атака"][1] );
	MA = MA + math.floor( MC.Stats["Магическая атака"][1] );
	PD = PD + math.floor( MC.Stats["Защита"][1] );
	MD = MD + math.floor( MC.Stats["Магическая защита"][1] );

	_G[ "mCardBookFrameStats_label11" ]:SetText( "Здоровье" );
	_G[ "mCardBookFrameStats_label12" ]:SetText( "Регенерация" );
	_G[ "mCardBookFrameStats_label13" ]:SetText( "Мана" );
	_G[ "mCardBookFrameStats_label14" ]:SetText( "Регенерация маны" );
	_G[ "mCardBookFrameStats_label15" ]:SetText( "Физическая атака" );
	_G[ "mCardBookFrameStats_label16" ]:SetText( "Магическая атака" );
	_G[ "mCardBookFrameStats_label17" ]:SetText( "Защита" );
	_G[ "mCardBookFrameStats_label18" ]:SetText( "Магическая защита" );
	_G[ "mCardBookFrameStats_label19" ]:SetText( "Уклонение" );
	_G[ "mCardBookFrameStats_label20" ]:SetText( "Сопротивлении магии" );
	_G[ "mCardBookFrameStats_label21" ]:SetText( "Меткость" );
	_G[ "mCardBookFrameStats_label22" ]:SetText( "Магическая меткость" );
	_G[ "mCardBookFrameStats_label23" ]:SetText( "Бонус исцеления" );

	_G[ "mCardBookFrameStats_labelex24" ]:SetText( "*" );
	_G[ "mCardBookFrameStats_labelex25" ]:SetText( "*" );
	_G[ "mCardBookFrameStats_labelex26" ]:SetText( "* единицы в секунду" );

	_G[ "mCardBookFrameStats_labelex11" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( HP ) ) );
	_G[ "mCardBookFrameStats_labelex12" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( HPR ) ) );
	_G[ "mCardBookFrameStats_labelex13" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( MP ) ) );
	_G[ "mCardBookFrameStats_labelex14" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( MPR ) ) );
	_G[ "mCardBookFrameStats_labelex15" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( PA ) ) );
	_G[ "mCardBookFrameStats_labelex16" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( MA ) ) );
	_G[ "mCardBookFrameStats_labelex17" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( PD ) ) );
	_G[ "mCardBookFrameStats_labelex18" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( MD ) ) );
	_G[ "mCardBookFrameStats_labelex19" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( PDR ) ) );
	_G[ "mCardBookFrameStats_labelex20" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( RES ) ) );
	_G[ "mCardBookFrameStats_labelex21" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( PACC ) ) );
	_G[ "mCardBookFrameStats_labelex22" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( MACC ) ) );
	_G[ "mCardBookFrameStats_labelex23" ]:SetText( MC.ui.PercentFormat( percent, MC.ui.ThSeparator( HB ) ) );

	mCardBookFrameStats_label10:SetText( "Итого:" );
	
	MC.ui.redrawCardList( mCardBookFrame_ScrollBar );

	UIDropDownMenu_SetSelectedID( mCardBookFrame_Race, MC.Vars["SelectedRaceMenuItem"] );
	UIDropDownMenu_SetSelectedID( mCardBookFrame_Stat, MC.Vars["SelectedStatMenuItem"] );
end;

function MC.ui.CountMessage()
	local percent = math.floor( MC.Vars.Owned * 100 / MC.Vars.NumCards );
	MC.Message( "Вами изучено " .. MC.ui.PercentFormat( percent, MC.Vars.Owned ) .. MC.cc .. " карт из " .. MC.ui.PercentFormat( 100, MC.Vars.NumCards ) .. MC.cc .. " возможных (" .. MC.ui.PercentFormat( percent ) .. MC.cc .. "% атласа)" );
	mCardBookFrame_CardList_Button0:SetText( MC.ui.PercentFormat( percent, MC.Vars.Owned ) .. " из " .. MC.Vars.NumCards .. " (" .. MC.ui.PercentFormat( percent ) .. "%)" );
end;

function MC.ui.CardListScrollOnValueChanged( this )
	local min, max = this:GetMinMaxValues()
	mCardBookFrame_ScrollBarScrollDownButton:Enable()
	mCardBookFrame_ScrollBarScrollUpButton:Enable()
	if this:GetValue() == min then
		mCardBookFrame_ScrollBarScrollUpButton:Disable()
	end
	if this:GetValue() == max then
		mCardBookFrame_ScrollBarScrollDownButton:Disable()
	end
	MC.ui.redrawCardList( mCardBookFrame_ScrollBar );
end;

function MC.ui.CardListScroll( this, delta )
	if (delta > 0) then
		this:SetValue(this:GetValue() - 2);
	elseif (delta < 0) then
		this:SetValue(this:GetValue() + 2);
	end;
end;

function MC.ui.redrawCardList( this )
	local _CardList = MC.tools.GetFilteredCardList();

	local max = #_CardList - 19;
	if( max < 0 )then max = 0; end;
	this:SetMinMaxValues( 0, max );
	for n = 1, 19 do
		local i = n + this:GetValue();
	
		local _text = "";
		
		if( i <= #_CardList )then
			_G[ "mCardBookFrame_CardList_Button" .. n ]:Show();
			if( _CardList[i]["owned"] )then
				_G[ "mCardBookFrame_CardList_Button" .. n .. "_delButton" ]:Show();
				_text = string.format( MC.Qualities[ _CardList[i]["rare"] ], _CardList[i]["name"] );
			else
				_G[ "mCardBookFrame_CardList_Button" .. n .. "_delButton" ]:Hide();
				_text = string.format( MC.Qualities[ 0 ], _CardList[i]["name"] );
			end;
			_G[ "mCardBookFrame_CardList_Button" .. n .. "_txt" ]:SetText( _text );
			
			local NTexture = _G[ "mCardBookFrame_CardList_Button" .. n ]:GetNormalTexture();
			if( _CardList[i]["name"] == MC.Vars["Selected"] )then
				NTexture:SetTexture( MCTexturePlaceHolder:GetPushedTexture() );
			else
				NTexture:SetTexture( nil );
			end;
		else
			_G[ "mCardBookFrame_CardList_Button" .. n ]:Hide();
		end;
	end;
end;

function MC.ui.ShowExtractHint( this )
	GameTooltip:SetOwner( this, "ANCHOR_LEFT", 4, 0 );
	GameTooltip:SetText( "Извлечь карту из атласа", 1, 1, 1 );
	GameTooltip:AddSeparator();
	GameTooltip:AddLine( "Извлеченная карта будет помещена в инвентарь" );
	GameTooltip:Show();
end;

function MC.ui.PercentFormat( percent, _percent )
	if( _percent == nil )then _percent = percent; end;
	local r, g;
	if( percent <= 50 )then
		r = MC.tools.dec2hex( math.floor( 255 * 1 ) );
		g = MC.tools.dec2hex( math.floor( 255 * ( percent * 2 / 100 ) ) );
	else
		percent = percent - 50;
		r = MC.tools.dec2hex( math.floor( 255 * ( 1 - ( percent * 2 / 100 ) ) ) );
		g = MC.tools.dec2hex( math.floor( 255 * 1 ) );
	end;
	if( string.len( r ) < 2 )then r = "0" .. r; end;
	if( string.len( g ) < 2 )then g = "0" .. g; end;
	return "|cff" .. r .. g .."00" .. _percent .. "|r";
end;

function MC.ui.Color( _table )
	local _r, _g, _b;
	_r = MC.tools.dec2hex( 255 * _table[ 1 ] );
	_g = MC.tools.dec2hex( 255 * _table[ 2 ] );
	_b = MC.tools.dec2hex( 255 * _table[ 3 ] );
	if( string.len( _r ) < 2 )then _r = "0" .. _r; end;
	if( string.len( _g ) < 2 )then _g = "0" .. _g; end;
	if( string.len( _b ) < 2 )then _b = "0" .. _b; end;
	return "|cff" .. _r .. _g .. _b;
end;

function MC.ui.ClassFormat( class, _class )
	if( MC.ClassColor[class] == nil )then
		class = "UNKNOWN";
	end;
	--local strChatColor = MC.tools.dec2hex( 255 * MC.ClassColor[class][1] ) .. MC.tools.dec2hex( 255 * MC.ClassColor[class][2] ) .. MC.tools.dec2hex( 255 * MC.ClassColor[class][3] );
	if( _class == nil )then _class = MC.ClassColor[class][4]; end;
	return MC.ui.Color( MC.ClassColor[class] ) .. _class .. "|r";
end;

function MC.ui.ThSeparator( str )
	local formatted = str;
	while true do
		formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1' .. "." .. '%2');
		if (k == 0) then
			break;
		end;
	end;
	return formatted;
end;

function MC.ui.ShowCardInfo( this, id )
	local _CardList = MC.tools.GetFilteredCardList();
	id = id + mCardBookFrame_ScrollBar:GetValue()
	local stCard = _CardList[ id ];
	local cardID = tonumber( stCard["hex"], 16 );
	
	if( stCard["owned"] )then
		local Racetext = LuaFunc_GetString( "SYS_RACE_" .. stCard["race"] )
		local Raretext = LuaFunc_GetString( "SYS_RARECOLOR_" .. ( stCard["rare"] - 2 ) )

		CardBookFrameCardType:SetText( Racetext )
		CardBookFrameCardName:SetText( stCard["name"] );
		CardBookFrameCardRare:SetText( Raretext )

		CardBookFrameCardSP:SetText( stCard["statname"] .. " +" .. stCard["statval"] );
		CardBookFrameCard2DImage:SetTexture( "interface\\CardFrame\\CardBk" .. stCard["resist"] );


		--CardBookFrameCardTip:SetText( stCard["descr"] );
		CardBookFrameCardNoteString:SetText( stCard["descr"] );
		CardBookFrameCardNoteScrollFrame:UpdateScrollChildRect();
	else
		CardBookFrameCardType:SetText( "" )
		CardBookFrameCardName:SetText( "? ? ?" );
		CardBookFrameCardSP:SetText( "" );
		CardBookFrameCardRare:SetText( "" )
		CardBookFrameCardTip:SetText( "" );
		CardBookFrameCard2DImage:SetTexture( "interface\\CardFrame\\CardBk0" );
	end;
	
	MC.Vars["Selected"] = stCard["name"];
	MC.ui.redrawCardList( mCardBookFrame_ScrollBar );
	LuaFunc_ShowCardImage( cardID );
end;

function MC.ui.ShowUnitTooltip()
	local sName = UnitName("mouseover");
	local sClass = UnitClassToken("mouseover");
	local sLevel = UnitLevel("mouseover");
	local sRace = UnitRace("mouseover")
	local nHealth = math.floor( UnitHealth("mouseover") * 100 / UnitMaxHealth("mouseover") );
	if( not MC.Mobs[sName] )and( UnitHealth("mouseover") == 100 )then
		MC.Mobs[sName] = UnitChangeHealth("mouseover");
	end;
	local health = UnitHealth("mouseover");
	local healthmax = UnitMaxHealth("mouseover");
	if( MC.Mobs[sName] )then
		healthmax = MC.Mobs[sName];
		health = math.floor( MC.Mobs[sName] * ( health / 100 ) );
	end;
	health = MC.ui.ThSeparator( health );
	healthmax = MC.ui.ThSeparator( healthmax );
	local _nHealth = nHealth .. "%"; if( _nHealth == "0%" )then _nHealth = "мёртв"; end;
	local nSex = UnitSex("mouseover");
	local sSex = "";
	if( nSex == 0 )then sSex = "Мужчина"; end;
	if( nSex == 1 )then sSex = "Женщина"; end;
	if( nSex == 2 )then sSex = "|cffFFFF00Элитный моб|r"; end;
	if( nSex > 2 )then sSex = "|cffFF0000Босс|r"; end;
		
	GameTooltip:SetText( sName, 1, 1, 1 );
	GameTooltip:AddLine( MC.ui.ClassFormat( sClass ) .. " (Уровень " .. MC.ui.ClassFormat( sClass, sLevel ) .. ")" );
	GameTooltip:AddLine( "Раса: " .. tostring( sRace ) );
	GameTooltip:AddLine( "Пол: " .. sSex );
	GameTooltip:AddLine( "Дистанция: " .. math.floor( UnitDistance("mouseover") ) );
	GameTooltip:AddLine( "Здоровье: " .. MC.ui.PercentFormat( nHealth, health ) .. " / " .. MC.ui.PercentFormat( 100, healthmax ) .. " (" .. MC.ui.PercentFormat( nHealth, _nHealth ) .. ")" );
	local QuestMsg = UnitQuestMsg("mouseover");    
	if (QuestMsg) then
		local newQuestMsg = MC.ui.cleanUpQuestMsg(QuestMsg);
		GameTooltip:AddLine(newQuestMsg, 1, 1, 1);
	end;
	GameTooltip:AddSeparator();
	local stCard = MC.tools.GetCardByName( sName );
	if( stCard ~= nil )then
		GameTooltip:AddLine( "|cff00B1E1" .. stCard["descr"] .. "|r" );
		GameTooltip:AddLine( "Карта добавляет: " .. MC.ui.ClassFormat( "KNIGHT", "+" .. stCard["statval"] .. " " .. stCard["statname"] ) );
		if( stCard["owned"] )then
			GameTooltip:AddLine( MC.ui.PercentFormat( 100, "Карта получена" ) );
		else
			GameTooltip:AddLine( MC.ui.PercentFormat( 0, "Карта отсутствует" ) );
		end;
	end;
end;

function MC.ui.IDRace()
	local menuitem = {};
	menuitem.checked = false

	menuitem.text = "Все"
	menuitem.func = function()
		MC.Vars["SelectedRace"] = -1;
		MC.Vars["SelectedRaceMenuItem"] = 1;
		UIDropDownMenu_SetSelectedID( mCardBookFrame_Race, 1 );
		MC.ui.redrawCardList( mCardBookFrame_ScrollBar );
	end;
	UIDropDownMenu_AddButton(menuitem, 1);
	
	for i = 1, #MC.Vars["Races"] do
		menuitem.text = LuaFunc_GetString( "SYS_RACE_" .. MC.Vars["Races"][ i ] );
		menuitem.func = function()
			MC.Vars["SelectedRace"] = MC.Vars["Races"][ i ];
			MC.Vars["SelectedRaceMenuItem"] = i + 1;
			UIDropDownMenu_SetSelectedID( mCardBookFrame_Race, i + 1 );
			MC.ui.redrawCardList( mCardBookFrame_ScrollBar );
		end;
		UIDropDownMenu_AddButton(menuitem, 1);
	end
	UIDropDownMenu_SetSelectedID(mCardBookFrame_Race, 1)
end;

function MC.ui.IDStat()
	local menuitem = {};
	menuitem.checked = false

	menuitem.text = "Все"
	menuitem.func = function()
		MC.Vars["SelectedStat"] = "";
		MC.Vars["SelectedStatMenuItem"] = 1;
		UIDropDownMenu_SetSelectedID( mCardBookFrame_Stat, 1 );
		MC.ui.redrawCardList( mCardBookFrame_ScrollBar );
	end;
	UIDropDownMenu_AddButton(menuitem, 1);
	
	local i = 2;
	for k, v in pairs( MC.Stats ) do
		menuitem.text = k;
		menuitem.func = function()
			MC.Vars["SelectedStat"] = k;
			MC.Vars["SelectedStatMenuItem"] = i;
			UIDropDownMenu_SetSelectedID( mCardBookFrame_Stat, i );
			MC.ui.redrawCardList( mCardBookFrame_ScrollBar );
		end;
		UIDropDownMenu_AddButton(menuitem, 1);
		i = i + 1;
	end
	UIDropDownMenu_SetSelectedID(mCardBookFrame_Stat, 1)
end;

--[[ pbInfo ]]
function MC.ui.cleanUpQuestMsg(questMsg)
	local newQuestMsgTable = { };
	local newQuestMsg = "";
	-- split up multiple quests (we get them from the game seperated with \n)
	for qline in string.gmatch(questMsg, "([^\n]+)\n?") do
		newQuestMsg = newQuestMsg .. MC.ui.cleanUpSingleQuestMsg(qline);
	end;
	return newQuestMsg;
end;

function pbIsEmpty(str, zero)
	if (type(str) == "nil" or str == "" or (zero == true and str == 0)) then
		return true;
	end;
	return false;
end;
	
function MC.ui.cleanUpSingleQuestMsg(questMsg)
	local newQuestMsg = "";
	--local p, q, r = string.match(questMsg, "([^(]+)%( (%d+) / (%d+) %)");
	local p = string.match(questMsg, "([^(]+)%(");
	local qRequestLine = "";
	-- if its not in the expected form just use what we get and be done with it
	if (type(p) == "nil") then
		return questMsg;
	end;
	-- We get the first line of every quest like this: "<QuestTitle> <QuestRequest>( x / y )"
	-- That means that we first have to find out, where exactly the QuestTitle ends
	-- and the QuestRequest starts. To do this, we check every quest we have and
	-- see if its title corresponds with the start of our questMsg
	local AQB_TQUESTS = GetNumQuestBookButton_QuestBook();
	local idx, catid, name, track, level, daily;
	local ret1, ret2, qRequest;
	for i = 1, AQB_TQUESTS do
		idx, catid, name, track, level, daily = GetQuestInfo(i);
		-- msg("idx: "..idx.." |name: "..name.." |track: "..track.." |level: "..level);
		ret1, ret2 = string.find(p, name, 1, true);

		-- if we find something, put together the new Quest Message to add to the tooltip
		if (not pbIsEmpty(ret1) and ret1 == 1) then
			--msg("ret1: "..ret1.." ret2: "..ret2);
			newQuestMsg = string.sub(p, ret1, ret2) .. ": ";

			qRequest = string.sub(p, ret2+1);
			qRequestLine = string.sub(questMsg, ret2+1);

			for p in string.gmatch(qRequestLine, "([^)]+%))\n?") do
				newQuestMsg = newQuestMsg .. MC.ui.cleanUpQuestMsgProcessQuestRequest(p);
			end;
		break;
		end;
	end;

	-- in case we did something wrong fall back to the input value
	if (string.len(newQuestMsg) <= 0) then
		local q, r;
		p, q, r = string.match(questMsg, "([^(]+)%( (%d+) / (%d+) %)");
		newQuestMsg = p .. "(" .. q .. "/" .. r .. ")";
	end;

	return newQuestMsg;
end;

function MC.ui.cleanUpQuestMsgProcessQuestRequest(qRequest)
	local newQuestRequest = "";
	-- first cut away leading and trailing spaces
	qRequest = string.gsub(qRequest, "^%s*(.-)%s*$", "%1");
	--msg("c: "..qRequest);
	-- lets go to work
	local p, q, r = string.match(qRequest, "([^(]+)%( (%d+) / (%d+) %)");
	-- special case: we get something like "( 11 / 25 )", where the text before the number is missing
	q, r = string.match(qRequest, "%( (%d+) / (%d+) %)");
    -- print out a fine colored quest request 
	if (p == nil) then
		p = UnitName("mouseover");
	end;
	local percent = math.floor( q * 100 / r );
	if( tonumber( q ) < tonumber( r ) )then
		newQuestRequest = "|cffFFFFFF " .. p .. "( |r" .. MC.ui.PercentFormat( percent, q ) .. "|cffFFFFFF / |r" .. MC.ui.PercentFormat( 100, r ) .. "|cffFFFFFF )|r";
	else
		newQuestRequest = MC.ui.PercentFormat( 100, p .. " ( условия выполнены! )" );
	end;
	return newQuestRequest .. "\n";
end;
--[[ pbInfo ]]

--[[ /run dofile("Interface/AddOns/mCardBook/code/ui.lua"); ]]